use clap::{Args, ValueEnum};
use image::io::Reader as ImageReader;
use std::io::Cursor;
use tool_helper::{Error, Input, Output};

mod color;

#[derive(Copy, Clone, PartialEq, Eq, PartialOrd, Ord, ValueEnum)]
pub enum ColorDepth {
    Clut4,
    Clut8,
    Full16,
}

#[derive(Args)]
pub struct Arguments {
    #[clap(arg_enum, value_parser)]
    color_depth: ColorDepth
}

fn convert_full16(input: Input, output: Output) -> Result<(), Error> {
    match ImageReader::new(Cursor::new(tool_helper::input_to_vec(input)?)).with_guessed_format()?.decode() {
        Ok(image) => {
            
            Ok(())
        },
        Err(error) => Err(Error::from_error(error))
    }
}

pub fn convert(args: Arguments, input: Input, output: Output) -> Result<(), Error> {
    match args.color_depth {
        ColorDepth::Full16 => convert_full16(input, output),
        _                  => Err(Error::not_implemented("Converting anything else then full16")),
    }
}